/********************************************************************
 *                                                                  *
 *   Source File: BPMCALC.cpp                                       *
 *   Description: Beats per Minute Calculator                       *
 *   Author:  Warren Hearnes, CIS:  71756,3711                      *
 *   Copyright, 1993						    *
 *   								    *
 *   This code is free to modify as you please, just don't change   *
 *   names, recompile, and call it your own, please :)  [The bare   *
 *   bones of this application was generated using the ProtoGen     *
 *   code generator.]  While this is not very complicated, it does  *
 *   address a lot of the tricks/pitfalls of a beginner's windows   *
 *   program using BWCC and OWL.  If you have any comments or       *
 *   questions, please let me know at the address above.            *
 *                                                                  *
 *   P.S.  I'm not an expert at this so if you see something wrong  *
 *   or if you know of a better way of doing things, I would        *
 *   appreciate hearing from you!                                   *
 *                                                                  *
 ********************************************************************/

#include <owl.h>
#include <dialog.h>
#include <stdio.h>
#include <string.h>
#include <bwcc.h>
// include file with definitions for the resource IDs.
#include "bpmid.h"

// Global variable declarations
BOOL InProcess = FALSE;		//Keeps track if RECORD has been pressed
long NumberEvents = 0;     	//Records number of times RECORD has been pressed
long StartTime, CurrentTime;    //Total time = CurrentTime - StartTime

/**********************************************************
 *   Application class					  *
 **********************************************************/

// Define application class derived from TApplication
class TBPMCALC : public TApplication
{
public:
   TBPMCALC(LPSTR AName, HINSTANCE hInstance, HINSTANCE hPrevInstance,
			LPSTR lpCmdLine, int nCmdShow)
			: TApplication(AName, hInstance, hPrevInstance, lpCmdLine,
			nCmdShow) {};
   virtual void InitMainWindow();
};

/**********************************************************
 *   Main Window class (dialog is used as main window)    *
 **********************************************************/

// Declare Bordlg_TMainWindow, a TDialog descendant...The Bordlg_xxx tells us
// that the dialog box is a derivative dialog class from BORDLG (see the BWCCAPI.RW
// file that came with Borland C++).  Don't forget to also define this class in the
// .RC file and the GetWindowClass function.
_CLASSDEF(Bordlg_TMainWindow)

class Bordlg_TMainWindow : public TDialog
{
public:
   Bordlg_TMainWindow(PTWindowsObject AParent, LPSTR ATitle);
   ~Bordlg_TMainWindow();
   virtual void Bordlg_TMainWindowRECORD(RTMessage Msg) = [ID_FIRST + RECORD];
   virtual void Bordlg_TMainWindowRESET(RTMessage Msg) = [ID_FIRST + RESET];
   virtual void Bordlg_TMainWindowEXIT(RTMessage Msg) = [ID_FIRST + EXIT];
   virtual void Bordlg_TMainWindowMORE_INFO(RTMessage Msg) = [ID_FIRST + MORE_INFO];

protected:
   // Must redefine the GetWindowClass and GetClassName functions for this new derived
   // class.
   virtual void GetWindowClass(WNDCLASS _FAR & AWndClass);
   virtual LPSTR GetClassName();
   // We'll redefine the SetupWindow function in order to center the main window dialog
   // horizontally regardless of user resolution.
   virtual void SetupWindow();

};

// Define Bordlg_TMainWindow, a TWindow constructor
Bordlg_TMainWindow::Bordlg_TMainWindow(PTWindowsObject AParent, LPSTR ATitle)
			: TDialog(AParent, ATitle) {}

// Define Bordlg_TMainWindow destructor
Bordlg_TMainWindow::~Bordlg_TMainWindow() {}

// Redefine GetClassName to return LPSTR to Bordlg_TMainWindow
LPSTR Bordlg_TMainWindow::GetClassName() { return "Bordlg_TMainWindow";}

// Redefine GetWindowClass to load application icon from resource and
// also redefine the default processing to BWCCDefDlgProc (see BWCCAPI.RW
// file again).  Notice the first call is to TDialog's GetWindowClass
// function--that is to let OWL do most of the work and then we only change
// the things we want to...
void Bordlg_TMainWindow::GetWindowClass(WNDCLASS _FAR & AWndClass)
{
   TDialog::GetWindowClass(AWndClass);
   AWndClass.hIcon = LoadIcon(GetApplication()->hInstance,
			MAKEINTRESOURCE(MainIcon));
   AWndClass.lpfnWndProc = BWCCDefDlgProc;
}

// Redefine SetupWindow to allow us to center the main window horizontally
// regardless of the user's resolution.  The GetWindowRect function returns
// a pointer to the RECT structure that contains the windows dimesions (in
// this case, WinRect) and the OffsetRect function puts the top left corner
// at (0,0)--therefore the width and height of the window is contained in the
// structure members WinRect.right and WinRect.bottom, respectively.
// Notice again that the TDialog::SetupWindow function is called to perform
// all the default processing and then MoveWindow is called to center the main
// window horizontally and 40 screen coord's down from the top (if we wanted
// to center vertically, the expression
//		  (GetSystemMetrics(SM_CXSCREEN)-WinRect.bottom)/2
// would replace the 40 parameter.
// The last point to make is that using the WinRect.right and WinRect.bottom
// variables is better than actually using the screen coordinates from your
// Resource Workshop file since the fonts may be different on the user's system.
// This will change the dimensions of the window.
void Bordlg_TMainWindow::SetupWindow()
   {
      RECT WinRect;
      GetWindowRect(HWindow, &WinRect);
      OffsetRect(&WinRect, -WinRect.left, -WinRect.top);
      TDialog::SetupWindow();
      MoveWindow(HWindow, (GetSystemMetrics(SM_CXSCREEN)-WinRect.right)/2, 40,
      	 WinRect.right, WinRect.bottom, FALSE);
   }

/**********************************************************
 *   Event processing for the buttons in the main window. *
 **********************************************************/

void Bordlg_TMainWindow::Bordlg_TMainWindowRECORD(RTMessage Msg)
{
   switch(Msg.LP.Hi)
   {
      case BN_CLICKED :
         // Check InProcess to see if the RECORD button has already been hit.
         if (InProcess)
            {
            char Output[40];
            // Increment the number of times the RECORD button has been hit.
            NumberEvents++;
	    // Get the MESSAGE time (there may be a delay between the current time
	    // and the message time) which will tell us exactly when the user hit the
            // RECORD button.
	    CurrentTime = GetMessageTime();
	    // Calculate the beats per minute (CurrentTime and StartTime are in
            // milliseconds starting at 0 when the application began).
            int BPM = 60000*NumberEvents/(CurrentTime-StartTime);
	    // The GetMessageTime function returns a long int and can roll over
            // so we want to check to make sure that doesn't happen.
            if (CurrentTime < StartTime)
	       // Remember, in order to use the BWCCMessageBox function, make sure you
	       // have included "bwcc.h" and have linked in BWCC.LIB in your project!
               BWCCMessageBox(HWindow, "Timer has rolled over limit and back to zero.  Beats/minute is now invalid.  Please press RESTART.",
		  "Warning", MB_ICONEXCLAMATION|MB_OK);
            sprintf(Output, "  Beats per minute:  %d      ", BPM);
            // Get DC to display current BPM.
            HDC TheDC;
	    TheDC = GetDC(HWindow);
            // Set the background color to the dark gray color of the BWCC group box.
            SetBkColor(TheDC, RGB(200,200,200));
	    TextOut(TheDC, 40, 10, Output, strlen(Output));
            // Remember to release the DC.
	    ReleaseDC(HWindow, TheDC);
            }
         else   
	    {
	    // RECORD had not been hit so set InProcess to TRUE since this is the
            // first hit.
	    InProcess = TRUE;
            // Set StartTime to the message time.
            StartTime = GetMessageTime();
            char Output[40] = "  Beats per minute:                  ";
	    // Get DC.
            HDC TheDC;
	    TheDC = GetDC(HWindow);
            // Set the background color to the dark gray color of the BWCC group box.
            SetBkColor(TheDC, RGB(200,200,200));
	    TextOut(TheDC, 40, 10, Output, strlen(Output));
            // Remember to release the DC.
	    ReleaseDC(HWindow, TheDC);
	    };
      break;
   }
}

void Bordlg_TMainWindow::Bordlg_TMainWindowRESET(RTMessage Msg)
{
   switch(Msg.LP.Hi)
   {
      case BN_CLICKED :
         // User hit RESET so reset InProcess and NumberEvents.
	 InProcess = FALSE;
	 NumberEvents = 0;
         // Overwrite last BPM with the standard startup message.
	 char Output[40] = "Press RECORD to begin...";
	 // Get DC.
         HDC TheDC;
	 TheDC = GetDC(HWindow);
         // Set the background color to the dark gray color of the BWCC group box.
         SetBkColor(TheDC, RGB(200,200,200));
	 TextOut(TheDC, 40, 10, Output, strlen(Output));
         // Remember to release the DC.
	 ReleaseDC(HWindow, TheDC);
      break;
   }
}

void Bordlg_TMainWindow::Bordlg_TMainWindowEXIT(RTMessage Msg)
{
   switch(Msg.LP.Hi)
   {
      case BN_CLICKED :
	 // This is a tough one!!!
	 CloseWindow();
      break;
   }
}

// Declare a dialog to pop up when the More Info... button is pressed.  This is
// a Bordlg (not a Bordlg_xxx) class dialog as shown in the .RC file. 
_CLASSDEF(TMoreInfoDlg)

// Declare TMoreInfoDlg, a TDialog descendant
class TMoreInfoDlg : public TDialog 
{
public:
   TMoreInfoDlg(PTWindowsObject AParent, LPSTR AName);
   ~TMoreInfoDlg();
   virtual void Ok(RTMessage Msg) = [ID_FIRST + IDOK];
};

// Define TMoreInfoDlg, a TDialog constructor
TMoreInfoDlg::TMoreInfoDlg(PTWindowsObject AParent, LPSTR AName)
			:TDialog(AParent, AName) {}

// Define TMoreInfoDlg destructor
TMoreInfoDlg::~TMoreInfoDlg() {}

// OWL handles the IDOK processing.
void TMoreInfoDlg::Ok(RTMessage Msg)
{
   switch(Msg.LP.Hi)
   {
      case BN_CLICKED :
	 TDialog::Ok(Msg);
   }
}

// Executes the MoreInfo dialog when the More Info... button is pressed.
void Bordlg_TMainWindow::Bordlg_TMainWindowMORE_INFO(RTMessage Msg)
{
   switch(Msg.LP.Hi)
   {
      case BN_CLICKED :
	 if(GetModule()->ExecDialog(new TMoreInfoDlg(this, "MoreInfo")) == IDOK) {}
   }
}

/***************************************************
 * TBPMCALCApp method implementations:
 ***************************************************/

// Construct the TBPMCALC's MainWindow of type Bordlg_TMainWindow
void TBPMCALC::InitMainWindow()
{
   MainWindow = new Bordlg_TMainWindow(NULL, "MainWindow");
}

// Main program
int PASCAL WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine,
                   int nCmdShow)
{
   HINSTANCE hBorLibrary;

   hBorLibrary = LoadLibrary("bwcc.dll");

   if((UINT)hBorLibrary <= 32)
      MessageBox(NULL, "Unable to load Borland Controls", "System Error", MB_OK | MB_ICONHAND);

   TBPMCALC BPMCALC ("Application Caption", hInstance, hPrevInstance,
      lpCmdLine, nCmdShow);

   BPMCALC.Run();

   if((UINT)hBorLibrary > 32)
      FreeLibrary(hBorLibrary);

   return BPMCALC.Status;
}
